## casacore 3.0.0

=== CMakeLists.txt ===
#
# Casacore
#
project(casacore)

cmake_minimum_required (VERSION 2.6.0)
include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
include(CheckFunctionExists)

# fixes warnings on cmake 3.x+ For now we want the old behavior to be backwards compatible
if (POLICY CMP0048)
    cmake_policy (SET CMP0048 OLD)
endif()

set(PROJECT_VERSION_MAJOR 3)
set(PROJECT_VERSION_MINOR 0)
set(PROJECT_VERSION_PATCH 0)
set(PROJECT_VERSION 
  "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

SET(PROJECT_SOVERSION 3)

SET(NO_SOVERSION FALSE CACHE BOOL "do not add version information to shared libraries")
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "casacore")
set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")

set(CPACK_PACKAGE_CONTACT "Malte Marquarding") #required
set(CPACK_PACKAGE_VENDOR "https://github.com/casacore/casacore")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Astronomical data processing library")

enable_language (Fortran)

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# By default build only Python2 bindings
option (BUILD_PYTHON "Build the python bindings" YES)
option (BUILD_PYTHON3 "Build the python3 bindings" NO)

# By default build shared libraries
option (ENABLE_SHARED "Build shared libraries" YES)

option (ENABLE_RPATH "Include rpath in executables and shared libraries" YES)

# By default do not use HDF5, FFTW3
option (ENABLE_TABLELOCKING "Make locking for concurrent table access possible" YES)
option (USE_HDF5 "Build HDF5 " NO)
option (USE_FFTW3 "Use FFTW instead of FFTPack" NO)
option (USE_THREADS "Use Mutex thread synchronization" YES)
option (USE_OPENMP "Use OpenMP threading" NO)
option (USE_MPI "Use MPI for parallel IO" NO)
option (USE_STACKTRACE "Show stacktrace in case of exception" NO)
option (CASA_BUILD "Building in the CASA (http://casa.nrao.edu) environment" NO)

set(CASA_DEFAULT_ALIGNMENT "32" CACHE STRING "Default alignment of casa::AlignedAllocator")

# ccache use is optional
option( UseCcache OFF )

if (UseCcache)
    message (STATUS "Searching for ccache.")
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        message (STATUS "Ccache found.")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif(CCACHE_FOUND)
endif()


# basic setup for building within CASA environment
if( CASA_BUILD )
   if( NOT DATA_DIR )
      set(DATA_DIR "%CASAROOT%/data")
   endif( )
   set(USE_FFTW3 ON)
   set(USE_OPENMP ON)
   set(USE_THREADS ON)
   set(BUILD_PYTHON OFF)
   set(Boost_NO_BOOST_CMAKE 1)
   if (EXISTS "/opt/casa/02/include/python2.7")
      ### RHEL7
      set(PYTHON_LIBRARY "/opt/casa/02/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/opt/casa/02/include/python2.7")
      set(NUMPY_INCLUDE_DIRS "/opt/casa/02/lib/python2.7/site-packages/numpy/core/include")
      set(PYTHON_EXECUTABLE:FILEPATH "/opt/casa/02/bin/python")
      if (EXISTS "/usr/include/boost")
         set(BOOST_ROOT "/usr")
      endif( )
      set(WCSLIB_INCLUDE_DIR "/opt/casa/02/include")
      set(WCSLIB_LIBRARY "/opt/casa/02/lib/libwcs.so")
      set(PYTHON2_NUMPY_INCLUDE_DIRS "/opt/casa/02/lib/python2.7/site-packages/numpy/core/include")
   elseif (EXISTS "/opt/casa/01/include/python2.7")
      ### RHEL7
      set(PYTHON_LIBRARY "/opt/casa/01/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/opt/casa/01/include/python2.7")
      set(PYTHON_EXECUTABLE:FILEPATH "/opt/casa/01/bin/python")
      if (EXISTS "/usr/include/boost")
         set(BOOST_ROOT "/usr")
      endif( )
   elseif(EXISTS "/usr/lib64/casa/01/include/python2.7")
      ### RHEL5/RHEL6
      set(PYTHON_LIBRARY "/usr/lib64/casa/01/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/usr/lib64/casa/01/include/python2.7")
      set(PYTHON_EXECUTABLE:FILEPATH "/usr/lib64/casa/01/bin/python")
      if (EXISTS "/usr/lib64/casa/01/include/boost")
         ### RHEL5
         set(BOOST_ROOT "/usr/lib64/casa/01")
      elseif (EXISTS "/usr/include/boost")
         ### RHEL6
         set(BOOST_ROOT="/usr")
      endif( )
   endif( )
endif( )

# Test if shared libraries have to be built.
if (ENABLE_SHARED)
    option (BUILD_SHARED_LIBS "" YES)
    if (ENABLE_RPATH)
        # Set RPATH to use for installed targets; append linker search path
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib" )
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
        set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
        set(CMAKE_MACOSX_RPATH TRUE)
    endif (ENABLE_RPATH)
	if( CASA_BUILD )
		option(NO_SOVERSION "Build shared libraries without version information" NO)
		if( NOT NO_SOVERSION )
			set( epochdelta 1385614800 )
			execute_process( COMMAND perl -e "$t=time( )-${epochdelta};$z=$t & 0xff; $y=($t>>8)&0xff; $x=($t>>16)&0xffff; print \"$x.$y.$z\""
					         OUTPUT_VARIABLE __casa_soversion )
			set(casa_soversion ${__casa_soversion} CACHE STRING "version for shared objects")
			message( STATUS "Shared object version number ${casa_soversion}" )
			file( WRITE ${CMAKE_INSTALL_PREFIX}/casa_sover.txt
				  "# generated by casacore/CMakeList.txt... Do not edit\n"
				  "${casa_soversion}\n" )
		else( )
			message( STATUS "User disabled shared library versioning" )
		endif( )
	endif( )
else()
    option (BUILD_SHARED_LIBS "" NO)
endif (ENABLE_SHARED)

if (UseCasaNamespace)
    add_definitions (-DUseCasaNamespace)
    message (STATUS "Using namespace casa. This will be deprecated at some point.")
else ()
    message (STATUS "Using namespace casacore.")
endif ()

# Define the compiler flags to be used.
# Note: -Wshadow and -Wunreachable-code give (too) many warnings.
# Casacore uses longlong, so no warnings for it.
# Clang gives warning on bison generated code; disable unneeded-internal-declaration.
if (NOT CMAKE_CXX_FLAGS)
    set (CMAKE_CXX_FLAGS "-Wextra -Wall -W -Wpointer-arith -Woverloaded-virtual -Wwrite-strings -pedantic -Wno-long-long")
#SET(CMAKE_CXX_FLAGS="-g -O0 -Wall -Wextra -Wshadow -Wunused-variable
# -Wunused-parameter -Wunused-function -Wunused -Wno-system-headers
# -Wno-deprecated -Woverloaded-virtual -Wwrite-strings -fprofile-arcs
# -ftest-coverage -Wold-style-cast -Weffc++ -Wconversion")
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unneeded-internal-declaration")
    endif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
endif (NOT CMAKE_CXX_FLAGS)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")

# Set build type if not given.
if (NOT CMAKE_BUILD_TYPE)
    # Use debug mode if building in dbg or debug directory.
    get_filename_component(_cmpvar ${CMAKE_BINARY_DIR} NAME)
    if(_cmpvar STREQUAL "dbg" OR _cmpvar STREQUAL "debug")
        set (CMAKE_BUILD_TYPE Debug)
    else()
        if(_cmpvar STREQUAL "cov")
            set (CMAKE_BUILD_TYPE Debug)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 --coverage")
            set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} --coverage")
        else()
            set (CMAKE_BUILD_TYPE Release)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG")
        endif(_cmpvar STREQUAL "cov")
    endif(_cmpvar STREQUAL "dbg" OR _cmpvar STREQUAL "debug")
endif (NOT CMAKE_BUILD_TYPE)

# Detect if the compiler supports C++11 if we want to use it.
check_cxx_compiler_flag(-std=c++11 HAS_CXX11)
if (HAS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
else()
    message(FATAL_ERROR "Casacore build requires a c++11 compatible compiler")
endif (HAS_CXX11)

# use faster fortran rules for complex operations, removes restoring complex
# infinities if naive computation results in NAN + NAN * I
#Handling complex multiplication and division with correct treating of complex
#infinities (one element Inf regardless of the other) according to the C is
#complicated.
#E.g. a = NaN + 1e30 i; a * a is not NaN but a complex infinity (-Inf - NaN).
#
#Treating this situation correctly has large performance impact. In GCC's
#implementation it is about 4 times slower than the naive implementation, with
#vectorization enabled the impact is even larger.
#As correct treatment of complex infinities when NaN appear in results is seldom
#accounted for, or not required and most other languages do not have these
#rules, the correct treatmeant can be disabled with the -fcx-fortran-rules flag.
#This changes the semantics to those of the FORTRAN language which is removes
#the need for rescuing the result when NaN appear. Python also follows FORTRAN
#rules.
#Additionally the correct behavior is not implemented in all compilers,
#most notably clang which is the default compiler on MacOS. So turning off
#correct treatment with GCC does not only make our code faster but also behave
#the same on more compilers.
#
#This has measurable impact on e.g. applycal where the cpu performance improves
#by about 20%.
# For one reason or another the check on the compiler flag has no
# effect; it still adds the option which fails for clang.
if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    check_cxx_compiler_flag(-fcx-fortran-rules HAS_GXX_FORTRAN_RULES)
    check_c_compiler_flag(-fcx-fortran-rules HAS_GCC_FORTRAN_RULES)
    # added before cmake flags so it can be disabled with
    # -fno-cx-fortran-rules for testing
    if (HAS_GXX_FORTRAN_RULES)
        set(CMAKE_CXX_FLAGS "-fcx-fortran-rules ${CMAKE_CXX_FLAGS}")
    endif()
    if (HAS_GCC_FORTRAN_RULES)
        set(CMAKE_C_FLAGS "-fcx-fortran-rules ${CMAKE_C_FLAGS}")
    endif()
else()
    # Ensure clang is not complaining about unused arguments.
    set(CMAKE_CXX_FLAGS "-Qunused-arguments ${CMAKE_CXX_FLAGS}")    
    set(CMAKE_C_FLAGS "-Qunused-arguments ${CMAKE_C_FLAGS}")    
endif()

# Since 2015, we need pwrite and pwrite (POSIX 2001)
check_function_exists(pread HAVE_PREAD)
check_function_exists(pwrite HAVE_PWRITE)
if (NOT (HAVE_PREAD AND HAVE_PWRITE))
        message(FATAL_ERROR "Casacore requires pread and pwrite functionality" )
endif (NOT (HAVE_PREAD AND HAVE_PWRITE))

# FindHDF5 uses environment variables, so set it if needed.
if (HDF5_ROOT_DIR)
    set (ENV{HDF5_ROOT} ${HDF5_ROOT_DIR})
endif (HDF5_ROOT_DIR)

# Find out which modules to build.
if (NOT MODULE)
   set (MODULE all)
endif (NOT MODULE)
set (_usebison YES)
set (_uselapack YES)
set (_usefits NO)
set (_usewcs NO)
set (_modules casa)
set (_modules2 )
if (NOT ${MODULE} STREQUAL "casa")
    set (_modules ${_modules} tables)
    set (_usebison YES)
    if (NOT ${MODULE} STREQUAL "tables")
        set (_modules ${_modules} scimath_f scimath measures meas)
        set (_uselapack YES)
        if (NOT ${MODULE} STREQUAL "measures")
            if (${MODULE} STREQUAL "ms")
                set (_modules ${_modules} ms derivedmscal)
            endif()
            if (${MODULE} STREQUAL "msfits" OR ${MODULE} STREQUAL "all")
                set (_modules2 ${_modules2} ms msfits derivedmscal)
                set (_usefits YES)
            endif()
            if (${MODULE} STREQUAL "images" OR ${MODULE} STREQUAL "all")
                set (_modules2 ${_modules2} lattices mirlib coordinates images)
                set (_usewcs YES)
                set (_usefits YES)
            endif()
        endif()
    endif()
endif()

if (_usefits)
    set (_modules ${_modules} fits)
endif()
set (_modules ${_modules} ${_modules2})

if (BUILD_PYTHON)
    set (_modules ${_modules} python)
endif (BUILD_PYTHON)

if (BUILD_PYTHON3)
    set (_modules ${_modules} python3)
endif (BUILD_PYTHON3)


# Determine which external packages to use.
include (CTest)

# Decrease test timeout. Valgrind times are excessive and need much more.
#set (CTEST_TEST_TIMEOUT 150 CACHE STRING
#    "Maximum ctest -S time allowed before CTest will kill the test." FORCE)
# Already a cache var. It can be overridden using ctest --timeout N
#set (DART_TESTING_TIMEOUT 150 CACHE STRING
#    "Maximum ctest time allowed before CTest will kill the test." FORCE)

find_package (DL)

=== casa/CMakeLists.txt ===
#
# CASA casa
#

configure_file (
  config.h.in
  "${PROJECT_BINARY_DIR}/casacore/casa/config.h"
  @ONLY)


set (
parser_inputs
JsonGram
)
 
foreach (src ${parser_inputs})
    BISON_TARGET (${src} Json/${src}.yy ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -p ${src}")
    FLEX_TARGET (${src} Json/${src}.ll ${CMAKE_CURRENT_BINARY_DIR}/${src}.lcc COMPILE_FLAGS "-P${src}")
endforeach (src)

include_directories (${CMAKE_CURRENT_BINARY_DIR})


add_library (casa_casa
Arrays/ArrayBase.cc
Arrays/ArrayError.cc
Arrays/ArrayOpsDiffShapes.cc
Arrays/ArrayPartMath.cc
Arrays/ArrayPosIter.cc
Arrays/ArrayUtil2.cc
Arrays/Array2.cc
Arrays/Array2Math.cc
Arrays/Array_tmpl.cc
Arrays/AxesMapping.cc
Arrays/AxesSpecifier.cc
Arrays/ExtendSpecifier.cc
Arrays/IPosition.cc
Arrays/IPosition2.cc
Arrays/MaskArrMath2.cc
Arrays/Matrix2Math.cc
Arrays/Matrix_tmpl.cc
Arrays/Slice.cc
Arrays/Slicer.cc
Arrays/Vector_tmpl.cc
BasicMath/Math.cc
BasicMath/Primes.cc
BasicMath/Random.cc
BasicSL/Complex.cc
BasicSL/Constants.cc
BasicSL/IComplex.cc
BasicSL/RegexBase.cc
BasicSL/STLMath.cc
BasicSL/String.cc
Containers/Allocator.cc
Containers/Block.cc
Containers/Block_tmpl.cc
Containers/HashMap2.cc
Containers/IterError.cc
Containers/List2.cc
Containers/Map2.cc
Containers/Record.cc
Containers/RecordDesc.cc
Containers/RecordDescRep.cc
Containers/RecordFieldId.cc
Containers/RecordField2Writer.cc
Containers/RecordInterface.cc
Containers/RecordRep.cc
Containers/Record2.cc
Containers/Record2Interface.cc
Containers/StackError.cc
Containers/Stack2.cc
Containers/ValueHolder.cc
Containers/ValueHolderRep.cc
Exceptions/Error2.cc
Exceptions/CasaErrorTools.cc
HDF5/HDF5DataSet.cc
HDF5/HDF5DataType.cc
HDF5/HDF5Error.cc
HDF5/HDF5File.cc
HDF5/HDF5Group.cc
HDF5/HDF5HidMeta.cc
HDF5/HDF5Object.cc
HDF5/HDF5Record.cc
Inputs/Input.cc
Inputs/Param.cc
IO/AipsIO.cc
IO/BaseSinkSource.cc
IO/BucketBase.cc
IO/BucketBuffered.cc
IO/BucketCache.cc
IO/BucketFile.cc
IO/BucketMapped.cc
IO/ByteIO.cc
IO/ByteSink.cc
IO/ByteSinkSource.cc
IO/ByteSource.cc
IO/CanonicalIO.cc
IO/ConversionIO.cc
IO/FilebufIO.cc
IO/FiledesIO.cc
IO/FileLocker.cc
IO/LECanonicalIO.cc
IO/LockFile.cc
IO/MemoryIO.cc
IO/MFFileIO.cc
IO/MMapfdIO.cc
IO/MMapIO.cc
IO/MultiFile.cc
IO/MultiFileBase.cc
IO/MultiHDF5.cc
IO/RawIO.cc
IO/RegularFileIO.cc
IO/StreamIO.cc
IO/TapeIO.cc
IO/TypeIO.cc
Json/JsonError.cc
Json/JsonKVMap.cc
Json/JsonOut.cc
Json/JsonParser.cc
Json/JsonValue.cc
Logging/LogFilter.cc
Logging/LogFilterInterface.cc
Logging/LogIO.cc
Logging/LogMessage.cc
Logging/LogOrigin.cc
Logging/LogSink.cc
Logging/LogSinkInterface.cc
Logging/MemoryLogSink.cc
Logging/NullLogSink.cc
Logging/StreamLogSink.cc
OS/CanonicalConversion.cc
OS/CanonicalDataConversion.cc
OS/Conversion.cc
OS/DataConversion.cc
OS/Directory.cc
OS/DirectoryIterator.cc
OS/DOos.cc
OS/DynLib.cc
OS/EnvVar.cc
OS/File.cc
OS/HostInfo.cc
OS/IBMConversion.cc
OS/IBMDataConversion.cc
OS/MemoryTrace.cc
OS/LECanonicalConversion.cc
OS/LECanonicalDataConversion.cc
OS/LittleEndianConversion.cc
OS/malloc.cc
OS/Memory.cc
OS/MemoryTrace.cc
OS/ModcompConversion.cc
OS/ModcompDataConversion.cc
OS/Mutex.cc
OS/OMP.cc
OS/Path.cc
OS/PrecTimer.cc
OS/RawDataConversion.cc
OS/RegularFile.cc
OS/SymLink.cc
OS/Time.cc
OS/Timer.cc
OS/VAXConversion.cc
OS/VAXDataConversion.cc
Quanta/Euler.cc
Quanta/MeasValue.cc
Quanta/MVAngle.cc
Quanta/MVBaseline.cc
Quanta/MVDirection.cc
Quanta/MVDoppler.cc
Quanta/MVDouble.cc
Quanta/MVEarthMagnetic.cc
Quanta/MVEpoch.cc
Quanta/MVFrequency.cc
Quanta/MVPosition.cc
Quanta/MVRadialVelocity.cc
Quanta/MVTime.cc
Quanta/MVuvw.cc
Quanta/QBase.cc
Quanta/QC.cc
Quanta/QLogical2.cc
Quanta/QMath2.cc
Quanta/QuantumHolder.cc
Quanta/Quantum2.cc
Quanta/RotMatrix.cc
Quanta/Unit.cc
Quanta/UnitDim.cc
Quanta/UnitMap.cc
Quanta/UnitMap2.cc
Quanta/UnitMap3.cc
Quanta/UnitMap4.cc
Quanta/UnitMap5.cc
Quanta/UnitMap6.cc
Quanta/UnitMap7.cc
Quanta/UnitName.cc
Quanta/UnitVal.cc
System/Aipsrc.cc
System/AipsrcBool.cc
System/AipsrcValue2.cc
System/AipsrcVBool.cc
System/AipsrcVString.cc
System/AppInfo.cc
System/AppState.cc
System/Casarc.cc
System/Choice.cc
System/ObjectID.cc
System/ObjectID2.cc
System/PGPlotter.cc
System/PGPlotterInterface.cc
System/PGPlotterNull.cc
System/ProgressMeter.cc
Utilities/BitVector.cc
Utilities/CountedPtr2.cc
Utilities/Compare.cc
Utilities/CompositeNumber.cc
Utilities/Copy2.cc
Utilities/cregex.cc
Utilities/DataType.cc
Utilities/DynBuffer.cc
Utilities/Fallible2.cc
Utilities/MUString.cc
Utilities/Notice.cc
Utilities/Precision.cc
Utilities/RecordTransformable.cc
Utilities/Regex.cc
Utilities/RegSequence.cc
Utilities/Sequence2.cc
Utilities/Sort.cc
Utilities/SortError.cc
Utilities/StringDistance.cc
Utilities/ValType.cc
aips.cc
version.cc
${BISON_JsonGram_OUTPUTS}
${FLEX_JsonGram_OUTPUTS}
)

if (HDF5_FOUND)
    list (APPEND de_libraries ${HDF5_LIBRARIES})
endif (HDF5_FOUND)
if (READLINE_FOUND)
    list (APPEND de_libraries ${READLINE_LIBRARIES})
endif (READLINE_FOUND)

target_link_libraries (
casa_casa
${de_libraries}
${libm}
dl
${CASACORE_ARCH_LIBS}
)

add_subdirectory (apps)

install (
TARGETS casa_casa
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Arrays/ArrayAccessor.h
Arrays/ArrayBase.h
Arrays/ArrayError.h
Arrays/Array.h
Arrays/Array.tcc
Arrays/ArrayIO.h
Arrays/ArrayIO.tcc
Arrays/ArrayIter.h
Arrays/ArrayIter.tcc
Arrays/ArrayLogical.h
Arrays/ArrayLogical.tcc
Arrays/ArrayMathBase.h
Arrays/ArrayMath.h
Arrays/ArrayMath.tcc
Arrays/ArrayOpsDiffShapes.h
Arrays/ArrayOpsDiffShapes.tcc
Arrays/ArrayPartMath.h
Arrays/ArrayPartMath.tcc
Arrays/ArrayPosIter.h
Arrays/ArrayUtil.h
Arrays/ArrayUtil.tcc
Arrays/AxesMapping.h
Arrays/AxesSpecifier.h
Arrays/Cube.h
Arrays/Cube.tcc
Arrays/ExtendSpecifier.h
Arrays/IPosition.h
Arrays/LogiArrayFwd.h
Arrays/LogiArray.h
Arrays/LogiCube.h
Arrays/LogiMatrix.h
Arrays/LogiVector.h
Arrays/MaskArrIO.h
Arrays/MaskArrIO.tcc
Arrays/MaskArrLogi.h
Arrays/MaskArrLogi.tcc
Arrays/MaskArrMath.h
Arrays/MaskArrMath.tcc
Arrays/MaskedArray.h
Arrays/MaskedArray.tcc
Arrays/MaskLogiArrFwd.h
Arrays/MaskLogiArr.h
Arrays/Matrix.h
Arrays/Matrix.tcc
Arrays/MatrixIter.h
Arrays/MatrixIter.tcc
Arrays/MatrixMath.h
Arrays/MatrixMath.tcc
Arrays/Slice.h
Arrays/Slicer.h
Arrays/Vector.h
Arrays/Vector.tcc
Arrays/Vector2.tcc
Arrays/VectorIter.h
Arrays/VectorIter.tcc
Arrays/VectorSTLIterator.h
DESTINATION include/casacore/casa/Arrays
)

install (FILES
BasicMath/ConvertScalar.h
BasicMath/Functional.h
BasicMath/Functional.tcc
BasicMath/Functors.h
BasicMath/Math.h
BasicMath/Primes.h
BasicMath/Random.h
BasicMath/StdLogical.h
DESTINATION include/casacore/casa/BasicMath
)

install (FILES
BasicSL/Complexfwd.h
BasicSL/Complex.h
BasicSL/Constants.h
BasicSL/IComplex.h
BasicSL/RegexBase.h
BasicSL/String.h
BasicSL/STLMath.h
BasicSL/STLIO.h
BasicSL/STLIO.tcc
DESTINATION include/casacore/casa/BasicSL
)

install (FILES
Containers/Allocator.h
Containers/Block.h
Containers/BlockIO.h
Containers/BlockIO.tcc
Containers/ContainerIO.h
Containers/HashMap.h
Containers/HashMap.tcc
Containers/HashMapIO.h
Containers/HashMapIO.tcc
Containers/HashMapIter.h
Containers/HashMapIter.tcc
Containers/IterError.h
Containers/Link.h
Containers/Link.tcc
Containers/List.h
Containers/List.tcc
Containers/ListIO.h
Containers/ListIO.tcc
Containers/Map.h
Containers/Map.tcc
Containers/MapIO.h
Containers/MapIO.tcc
Containers/ObjectStack.h
Containers/ObjectStack.tcc
Containers/OrderedMap.h
Containers/OrderedMap.tcc
Containers/OrderedPair.h
Containers/OrderedPair.tcc
Containers/OrdMapIO.h
Containers/OrdMapIO.tcc
Containers/OrdPairIO.h
Containers/OrdPairIO.tcc
Containers/Queue.h
Containers/Queue.tcc
Containers/RecordDesc.h
Containers/RecordDescRep.h
Containers/RecordField.h
Containers/RecordField.tcc
Containers/RecordFieldId.h
Containers/RecordFieldWriter.h
Containers/RecordFieldWriter.tcc
Containers/Record.h
Containers/RecordInterface.h
Containers/RecordRep.h
Containers/SimOrdMap.h
Containers/SimOrdMap.tcc
Containers/SimOrdMapIO.h
Containers/SimOrdMapIO.tcc
Containers/StackError.h
Containers/Stack.h
Containers/Stack.tcc
Containers/ValueHolder.h
Containers/ValueHolderRep.h
DESTINATION include/casacore/casa/Containers
)

install (FILES
Exceptions/CasaErrorTools.h
Exceptions/Error.h
Exceptions/Error.tcc
DESTINATION include/casacore/casa/Exceptions
)

install (FILES
HDF5/HDF5DataSet.h
HDF5/HDF5DataType.h
HDF5/HDF5Error.h
HDF5/HDF5File.h
HDF5/HDF5Group.h
HDF5/HDF5HidMeta.h
HDF5/HDF5Object.h
HDF5/HDF5Record.h
DESTINATION include/casacore/casa/HDF5
)

install (FILES
Inputs/Input.h
Inputs/Param.h
DESTINATION include/casacore/casa/Inputs
)

install (FILES
IO/AipsIOCarray.h
IO/AipsIOCarray.tcc
IO/AipsIO.h
IO/BaseSinkSource.h
IO/BucketBase.h
IO/BucketBuffered.h
IO/BucketCache.h
IO/BucketFile.h
IO/BucketMapped.h
IO/ByteIO.h
IO/ByteSink.h
IO/ByteSinkSource.h
IO/ByteSource.h
IO/CanonicalIO.h
IO/ConversionIO.h
IO/FilebufIO.h
IO/FiledesIO.h
IO/FileLocker.h
IO/LargeFilebufIO.h
IO/LargeFiledesIO.h
IO/LargeIOFuncDef.h
IO/LargeRegularFileIO.h
IO/LECanonicalIO.h
IO/LockFile.h
IO/MemoryIO.h
IO/MFFileIO.h
IO/MMapfdIO.h
IO/MMapIO.h
IO/MultiFile.h
IO/MultiFileBase.h
IO/MultiHDF5.h
IO/RawIO.h
IO/RegularFileIO.h
IO/StreamIO.h
IO/TapeIO.h
IO/TypeIO.h
DESTINATION include/casacore/casa/IO
)

install (FILES
Json/JsonError.h
Json/JsonKVMap.h
Json/JsonOut.h
Json/JsonOut.tcc
Json/JsonParser.h
Json/JsonValue.h
DESTINATION include/casacore/casa/Json
)

install (FILES
Logging/LogFilter.h
Logging/LogFilterInterface.h
Logging/LogIO.h
Logging/LogMessage.h
Logging/LogOrigin.h
Logging/LogSink.h
Logging/LogSinkInterface.h
Logging/MemoryLogSink.h
Logging/NullLogSink.h
Logging/StreamLogSink.h
DESTINATION include/casacore/casa/Logging
)

install (FILES
OS/CanonicalConversion.h
OS/CanonicalDataConversion.h
OS/Conversion.h
OS/DataConversion.h
OS/Directory.h
OS/DirectoryIterator.h
OS/DOos.h
OS/DynLib.h
OS/EnvVar.h
OS/File.h
OS/HostInfoBsd.h
OS/HostInfoDarwin.h
OS/HostInfo.h
OS/HostInfoHpux.h
OS/HostInfoIrix.h
OS/HostInfoLinux.h
OS/HostInfoOsf1.h
OS/HostInfoSolaris.h
OS/IBMConversion.h
OS/IBMDataConversion.h
OS/LECanonicalConversion.h
OS/LECanonicalDataConversion.h
OS/LittleEndianConversion.h
OS/malloc.h
OS/Memory.h
OS/MemoryTrace.h
OS/ModcompConversion.h
OS/ModcompDataConversion.h
OS/Mutex.h
OS/OMP.h
OS/Path.h
OS/PrecTimer.h
OS/RawDataConversion.h
OS/RegularFile.h
OS/SymLink.h
OS/Time.h
OS/Timer.h
OS/VAXConversion.h
OS/VAXDataConversion.h
DESTINATION include/casacore/casa/OS
)

install (FILES
Quanta/Euler.h
Quanta/MeasValue.h
Quanta/MVAngle.h
Quanta/MVBaseline.h
Quanta/MVDirection.h
Quanta/MVDoppler.h
Quanta/MVDouble.h
Quanta/MVEarthMagnetic.h
Quanta/MVEpoch.h
Quanta/MVFrequency.h
Quanta/MVPosition.h
Quanta/MVRadialVelocity.h
Quanta/MVTime.h
Quanta/MVuvw.h
Quanta/QBase.h
Quanta/QC.h
Quanta/QLogical.h
Quanta/QLogical.tcc
Quanta/QMath.h
Quanta/QMath.tcc
Quanta/Quantum.h
Quanta/Quantum.tcc
Quanta/QVector.h
Quanta/QVector.tcc
Quanta/QuantumHolder.h
Quanta/QuantumType.h
Quanta/RotMatrix.h
Quanta/UnitDim.h
Quanta/Unit.h
Quanta/UnitMap.h
Quanta/UnitName.h
Quanta/UnitVal.h
DESTINATION include/casacore/casa/Quanta
)

install (FILES
System/Aipsrc.h
System/AipsrcValue.h
System/AipsrcValue.tcc
System/AipsrcVector.h
System/AipsrcVector.tcc
System/AppInfo.h
System/AppState.h
System/Casarc.h
System/Choice.h
System/ObjectID.h
System/PGPlotter.h
System/PGPlotterInterface.h
System/PGPlotterNull.h
System/ProgressMeter.h
DESTINATION include/casacore/casa/System
)

install (FILES
Utilities/Assert.h
Utilities/Assert.tcc
Utilities/BinarySearch.h
Utilities/BinarySearch.tcc
Utilities/BitVector.h
Utilities/CASATask.h
Utilities/Compare.h
Utilities/Compare.tcc
Utilities/CompositeNumber.h
Utilities/Copy.h
Utilities/Copy.tcc
Utilities/CountedPtr.h
Utilities/CountedPtr.tcc
Utilities/COWPtr.h
Utilities/COWPtr.tcc
Utilities/cregex.h
Utilities/DataType.h
Utilities/DefaultValue.h
Utilities/DynBuffer.h
Utilities/Fallible.h
Utilities/generic.h
Utilities/GenSort.h
Utilities/GenSort.tcc
Utilities/LinearSearch.h

=== lattices/CMakeLists.txt ===
#
# CASA Lattices
#

add_library (casa_lattices
Lattices/Lattices_tmpl.cc
Lattices/LatticeBase.cc
Lattices/LatticeIndexer.cc
Lattices/LatticeLocker.cc
Lattices/LatticeNavigator.cc
Lattices/LatticeStepper.cc
Lattices/PixelCurve1D.cc
Lattices/TileStepper.cc
Lattices/TiledLineStepper.cc
Lattices/TiledShape.cc
LatticeMath/Fit2D.cc
LatticeMath/LatticeAddNoise.cc
LatticeMath/LatticeCleanProgress.cc
LatticeMath/LatticeFit.cc
LatticeMath/LatticeHistProgress.cc
LatticeMath/LatticeHistSpecialize.cc
LatticeMath/LatticeProgress.cc
LatticeMath/LatticeStatsBase.cc
LatticeMath/LattStatsProgress.cc
LatticeMath/LattStatsSpecialize.cc
LEL/LatticeExprNode.cc
LEL/LELArrayBase.cc
LEL/LELAttribute.cc
LEL/LELBinary2.cc
LEL/LELCoordinates.cc
LEL/LELFunction2.cc
LEL/LELLattCoord.cc
LEL/LELLattCoordBase.cc
LEL/LELRegion.cc
LEL/LELUnary2.cc
LRegions/FITSMask.cc
LRegions/LatticeRegion.cc
LRegions/LattRegionHolder.cc
LRegions/LCBox.cc
LRegions/LCComplement.cc
LRegions/LCConcatenation.cc
LRegions/LCDifference.cc
LRegions/LCEllipsoid.cc
LRegions/LCExtension.cc
LRegions/LCHDF5Mask.cc
LRegions/LCIntersection.cc
LRegions/LCLELMask.cc
LRegions/LCMask.cc
LRegions/LCPagedMask.cc
LRegions/LCPixelSet.cc
LRegions/LCPolygon.cc
LRegions/LCRegion.cc
LRegions/LCRegion2.cc
LRegions/LCRegionFixed.cc
LRegions/LCRegionMulti.cc
LRegions/LCRegionSingle.cc
LRegions/LCSlicer.cc
LRegions/LCStretch.cc
LRegions/LCUnion.cc
LRegions/RegionType.cc
)

target_link_libraries (
casa_lattices
casa_tables
casa_scimath
${CASACORE_ARCH_LIBS}
)

install (TARGETS casa_lattices
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Lattices/ArrayLattice.h
Lattices/ArrayLattice.tcc
Lattices/CurvedLattice2D.h
Lattices/CurvedLattice2D.tcc
Lattices/ExtendLattice.h
Lattices/ExtendLattice.tcc
Lattices/HDF5LattIter.h
Lattices/HDF5LattIter.tcc
Lattices/HDF5Lattice.h
Lattices/HDF5Lattice.tcc
Lattices/Lattice.h
Lattices/Lattice.tcc
Lattices/LatticeBase.h
Lattices/LatticeCache.h
Lattices/LatticeCache.tcc
Lattices/LatticeConcat.h
Lattices/LatticeConcat.tcc
Lattices/LatticeIndexer.h
Lattices/LatticeIterInterface.h
Lattices/LatticeIterInterface.tcc
Lattices/LatticeIterator.h
Lattices/LatticeIterator.tcc
Lattices/LatticeLocker.h
Lattices/LatticeNavigator.h
Lattices/LatticeStepper.h
Lattices/LatticeUtilities.h
Lattices/LatticeUtilities.tcc
Lattices/MaskedLattice.h
Lattices/MaskedLattice.tcc
Lattices/MaskedLatticeIterator.h
Lattices/MaskedLatticeIterator.tcc
Lattices/PagedArrIter.h
Lattices/PagedArrIter.tcc
Lattices/PagedArray.h
Lattices/PagedArray.tcc
Lattices/PixelCurve1D.h
Lattices/RebinLattice.h
Lattices/RebinLattice.tcc
Lattices/SubLattice.h
Lattices/SubLattice.tcc
Lattices/TempLattice.h
Lattices/TempLattice.tcc
Lattices/TempLatticeImpl.h
Lattices/TempLatticeImpl.tcc
Lattices/TileStepper.h
Lattices/TiledLineStepper.h
Lattices/TiledShape.h
DESTINATION include/casacore/lattices/Lattices
)

install (FILES
LatticeMath/StatsTiledCollapser.h
LatticeMath/StatsTiledCollapser.tcc
LatticeMath/CLIPNearest2D.h
LatticeMath/CLIPNearest2D.tcc
LatticeMath/CLInterpolator2D.h
LatticeMath/CLInterpolator2D.tcc
LatticeMath/Fit2D.h
LatticeMath/Fit2D2.tcc
LatticeMath/LatticeAddNoise.h
LatticeMath/LatticeAddNoise2.tcc
LatticeMath/LatticeApply.h
LatticeMath/LatticeApply.tcc
LatticeMath/LatticeCleanProgress.h
LatticeMath/LatticeCleaner.h
LatticeMath/LatticeCleaner.tcc
LatticeMath/LatticeConvolver.h
LatticeMath/LatticeConvolver.tcc
LatticeMath/LatticeFFT.h
LatticeMath/LatticeFFT.tcc
LatticeMath/LatticeFit.h
LatticeMath/LatticeFractile.h
LatticeMath/LatticeFractile.tcc
LatticeMath/LatticeHistProgress.h
LatticeMath/LatticeHistSpecialize.h
LatticeMath/LatticeHistSpecialize2.tcc
LatticeMath/LatticeHistograms.h
LatticeMath/LatticeHistograms.tcc
LatticeMath/LatticeMathUtil.h
LatticeMath/LatticeMathUtil.tcc
LatticeMath/LatticeProgress.h
LatticeMath/LatticeSlice1D.h
LatticeMath/LatticeSlice1D.tcc
LatticeMath/LatticeStatistics.h
LatticeMath/LatticeStatistics.tcc
LatticeMath/LatticeStatsBase.h
LatticeMath/LatticeStatsDataProvider.h
LatticeMath/LatticeStatsDataProvider.tcc
LatticeMath/LatticeStatsDataProviderBase.h
LatticeMath/LatticeStatsDataProviderBase.tcc
LatticeMath/LatticeTwoPtCorr.h
LatticeMath/LatticeTwoPtCorr.tcc
LatticeMath/LattStatsProgress.h
LatticeMath/LattStatsSpecialize.h
LatticeMath/LattStatsSpecialize2.tcc
LatticeMath/LineCollapser.h
LatticeMath/LineCollapser.tcc
LatticeMath/MaskedLatticeStatsDataProvider.h
LatticeMath/MaskedLatticeStatsDataProvider.tcc
LatticeMath/MultiTermLatticeCleaner.h
LatticeMath/MultiTermLatticeCleaner.tcc
LatticeMath/TiledCollapser.h
LatticeMath/TiledCollapser.tcc
DESTINATION include/casacore/lattices/LatticeMath
)

install (FILES
LEL/LatticeExpr.h
LEL/LatticeExpr.tcc
LEL/LatticeExprNode.h
LEL/LELArray.h
LEL/LELArray.tcc
LEL/LELArrayBase.h
LEL/LELAttribute.h
LEL/LELBinary.h
LEL/LELBinary.tcc
LEL/LELBinary2.h
LEL/LELBinaryEnums.h
LEL/LELCondition.h
LEL/LELCondition.tcc
LEL/LELConvert.h
LEL/LELConvert.tcc
LEL/LELCoordinates.h
LEL/LELFunction.h
LEL/LELFunction.tcc
LEL/LELFunction2.h
LEL/LELFunctionEnums.h
LEL/LELInterface.h
LEL/LELInterface.tcc
LEL/LELLattCoord.h
LEL/LELLattCoordBase.h
LEL/LELLattice.h
LEL/LELLattice.tcc
LEL/LELRegion.h
LEL/LELScalar.h
LEL/LELScalar.tcc
LEL/LELSpectralIndex.h
LEL/LELSpectralIndex.tcc
LEL/LELUnary.h
LEL/LELUnary.tcc
LEL/LELUnary2.h
LEL/LELUnaryEnums.h
DESTINATION include/casacore/lattices/LEL
)

install (FILES
LRegions/FITSMask.h
LRegions/LatticeRegion.h
LRegions/LattRegionHolder.h
LRegions/LCBox.h
LRegions/LCComplement.h
LRegions/LCConcatenation.h
LRegions/LCDifference.h
LRegions/LCEllipsoid.h
LRegions/LCExtension.h
LRegions/LCHDF5Mask.h
LRegions/LCIntersection.h
LRegions/LCLELMask.h
LRegions/LCMask.h
LRegions/LCPagedMask.h
LRegions/LCPixelSet.h
LRegions/LCPolygon.h
LRegions/LCRegion.h
LRegions/LCRegionFixed.h
LRegions/LCRegionMulti.h
LRegions/LCRegionSingle.h
LRegions/LCSlicer.h
LRegions/LCStretch.h
LRegions/LCUnion.h
LRegions/RegionType.h
DESTINATION include/casacore/lattices/LRegions
)

install (FILES
LatticeMath.h
Lattices.h
LEL.h
LRegions.h
DESTINATION include/casacore/lattices
)

# The tests
add_subdirectory (Lattices/test ${EXCL_ALL})
add_subdirectory (LatticeMath/test ${EXCL_ALL})
add_subdirectory (LEL/test ${EXCL_ALL})
add_subdirectory (LRegions/test ${EXCL_ALL})

=== tables/CMakeLists.txt ===
#
# CASA Tables
#

set (
parser_inputs
RecordGram
TableGram
)

 
foreach (src ${parser_inputs})
    BISON_TARGET (${src} TaQL/${src}.yy ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -p ${src}")
    FLEX_TARGET (${src} TaQL/${src}.ll ${CMAKE_CURRENT_BINARY_DIR}/${src}.lcc COMPILE_FLAGS "-P${src}")
endforeach (src)
 

include_directories (${CMAKE_CURRENT_BINARY_DIR})

# Add SOVERSION definition for files needing it.
foreach (src DataMan/DataManager.cc TaQL/UDFBase.cc)
    set_source_files_properties(${src}
                 PROPERTIES COMPILE_FLAGS -DSOVERSION=${LIB_SOVERSION})
endforeach (src)

add_library (casa_tables
Tables/ArrayColumn_tmpl.cc
Tables/ArrColDesc_tmpl.cc
Tables/BaseColDesc.cc
Tables/BaseColumn.cc
Tables/BaseTabIter.cc
Tables/BaseTable.cc
Tables/ColDescSet.cc
Tables/ColumnCache.cc
Tables/ColumnDesc.cc
Tables/ColumnSet.cc
Tables/ColumnsIndex.cc
Tables/ColumnsIndexArray.cc
Tables/ConcatColumn.cc
Tables/ConcatRows.cc
Tables/ConcatTable.cc
Tables/ExternalLockSync.cc
Tables/MemoryTable.cc
Tables/NullTable.cc
Tables/PlainColumn.cc
Tables/PlainTable.cc
Tables/ReadAsciiTable.cc
Tables/RefColumn.cc
Tables/RefRows.cc
Tables/RefTable.cc
Tables/RowCopier.cc
Tables/ScaColDesc_tmpl.cc
Tables/ScalarColumn_tmpl.cc
Tables/ScaRecordColData.cc
Tables/ScaRecordColDesc.cc
Tables/SetupNewTab.cc
Tables/StorageOption.cc
Tables/SubTabDesc.cc
Tables/TabPath.cc
Tables/Table.cc
Tables/TableAttr.cc
Tables/TableCache.cc
Tables/TableColumn.cc
Tables/TableCopy.cc
Tables/TableDesc.cc
Tables/TableError.cc
Tables/TableIndexProxy.cc
Tables/TableInfo.cc
Tables/TableIter.cc
Tables/TableIterProxy.cc
Tables/TableKeyword.cc
Tables/TableLock.cc
Tables/TableLockData.cc
Tables/TableLocker.cc
Tables/TableProxy.cc
Tables/TableRecord.cc
Tables/TableRecordRep.cc
Tables/TableRow.cc
Tables/TableRowProxy.cc
Tables/TableSyncData.cc
Tables/TableTrace.cc
DataMan/BitFlagsEngine.cc
DataMan/CompressComplex.cc
DataMan/CompressFloat.cc
DataMan/DataManAccessor.cc
DataMan/DataManError.cc
DataMan/DataManInfo.cc
DataMan/DataManager.cc
DataMan/ForwardCol.cc
DataMan/ForwardColRow.cc
DataMan/ISMBase.cc
DataMan/ISMBucket.cc
DataMan/ISMColumn.cc
DataMan/ISMIndColumn.cc
DataMan/ISMIndex.cc
DataMan/IncrStManAccessor.cc
DataMan/IncrementalStMan.cc
DataMan/MSMBase.cc
DataMan/MSMColumn.cc
DataMan/MSMDirColumn.cc
DataMan/MSMIndColumn.cc
DataMan/MemoryStMan.cc
DataMan/SSMBase.cc
DataMan/SSMColumn.cc
DataMan/SSMDirColumn.cc
DataMan/SSMIndColumn.cc
DataMan/SSMIndStringColumn.cc
DataMan/SSMIndex.cc
DataMan/SSMStringHandler.cc
DataMan/StArrAipsIO.cc
DataMan/StArrayFile.cc
DataMan/StIndArrAIO.cc
DataMan/StIndArray.cc
DataMan/StManAipsIO.cc
DataMan/StManColumn.cc
DataMan/StandardStMan.cc
DataMan/StandardStManAccessor.cc
DataMan/TSMColumn.cc
DataMan/TSMCoordColumn.cc
DataMan/TSMCube.cc
DataMan/TSMCubeBuff.cc
DataMan/TSMCubeMMap.cc
DataMan/TSMDataColumn.cc
DataMan/TSMFile.cc
DataMan/TSMIdColumn.cc
DataMan/TSMOption.cc
DataMan/TSMShape.cc
DataMan/TiledCellStMan.cc
DataMan/TiledColumnStMan.cc
DataMan/TiledDataStMan.cc
DataMan/TiledDataStManAccessor.cc
DataMan/TiledFileAccess.cc
DataMan/TiledFileHelper.cc
DataMan/TiledShapeStMan.cc
DataMan/TiledStMan.cc
DataMan/TiledStManAccessor.cc
DataMan/VirtColEng.cc
DataMan/VirtualTaQLColumn.cc
TaQL/ExprAggrNode.cc
TaQL/ExprAggrNodeArray.cc
TaQL/ExprConeNode.cc
TaQL/ExprDerNode.cc
TaQL/ExprDerNodeArray.cc
TaQL/ExprFuncNode.cc
TaQL/ExprFuncNodeArray.cc
TaQL/ExprGroup.cc
TaQL/ExprGroupAggrFunc.cc
TaQL/ExprGroupAggrFuncArray.cc
TaQL/ExprLogicNode.cc
TaQL/ExprLogicNodeArray.cc
TaQL/ExprMathNode.cc
TaQL/ExprMathNodeArray.cc
TaQL/ExprNode.cc
TaQL/ExprNodeArray.cc
TaQL/ExprNodeRecord.cc
TaQL/ExprNodeRep.cc
TaQL/ExprNodeSet.cc
TaQL/ExprRange.cc
TaQL/ExprUDFNode.cc
TaQL/ExprUDFNodeArray.cc
TaQL/ExprUnitNode.cc
TaQL/MArrayBase.cc
TaQL/RecordExpr.cc
TaQL/RecordGram.cc
TaQL/TaQLNode.cc
TaQL/TaQLNodeDer.cc
TaQL/TaQLNodeHandler.cc
TaQL/TaQLNodeRep.cc
TaQL/TaQLNodeResult.cc
TaQL/TaQLNodeVisitor.cc
TaQL/TaQLResult.cc
TaQL/TaQLShow.cc
TaQL/TaQLStyle.cc
TaQL/TableExprData.cc
TaQL/TableExprId.cc
TaQL/TableGram.cc
TaQL/TableParse.cc
TaQL/UDFBase.cc
LogTables/TableLogSink.cc
LogTables/NewFile.cc
LogTables/LoggerHolder.cc
LogTables/LogFilterTaql.cc
LogTables/LogFilterExpr.cc
${BISON_RecordGram_OUTPUTS}
${FLEX_RecordGram_OUTPUTS}
${BISON_TableGram_OUTPUTS}
${FLEX_TableGram_OUTPUTS}
)

if(MPI_FOUND)
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)
    target_compile_definitions(casa_tables PRIVATE HAVE_MPI)
    target_link_libraries(casa_tables casa_casa ${CASACORE_ARCH_LIBS} MPI::MPI_C)
else()
    target_link_libraries (casa_tables casa_casa ${CASACORE_ARCH_LIBS})
endif()



add_subdirectory (apps)

install (TARGETS casa_tables
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Tables/ArrColData.h
Tables/ArrColData.tcc
Tables/ArrColDesc.h
Tables/ArrColDesc.tcc
Tables/ArrayColumn.h
Tables/ArrayColumn.tcc
Tables/ArrayColumnFunc.h
Tables/BaseColDesc.h
Tables/BaseColumn.h
Tables/BaseTabIter.h
Tables/BaseTable.h
Tables/ColDescSet.h
Tables/ColumnCache.h
Tables/ColumnDesc.h
Tables/ColumnSet.h
Tables/ColumnsIndex.h
Tables/ColumnsIndexArray.h
Tables/ConcatColumn.h
Tables/ConcatRows.h
Tables/ConcatScalarColumn.h
Tables/ConcatScalarColumn.tcc
Tables/ConcatTable.h
Tables/ExternalLockSync.h
Tables/MemoryTable.h
Tables/NullTable.h
Tables/PlainColumn.h
Tables/PlainTable.h
Tables/ReadAsciiTable.h
Tables/RefColumn.h
Tables/RefRows.h
Tables/RefTable.h
Tables/RowCopier.h
Tables/ScaColData.h
Tables/ScaColData.tcc
Tables/ScaColDesc.h
Tables/ScaColDesc.tcc
Tables/ScaRecordColData.h
Tables/ScaRecordColDesc.h
Tables/ScalarColumn.h
Tables/ScalarColumn.tcc
Tables/SetupNewTab.h
Tables/StorageOption.h
Tables/SubTabDesc.h
Tables/TVec.h
Tables/TVec.tcc
Tables/TVecLogic.h
Tables/TVecLogic.tcc
Tables/TVecMath.h
Tables/TVecMath.tcc
Tables/TVecScaCol.h
Tables/TVecScaCol.tcc
Tables/TVecTemp.h
Tables/TVecTemp.tcc
Tables/TabPath.h
Tables/TabVecLogic.h
Tables/TabVecLogic.tcc
Tables/TabVecMath.h
Tables/TabVecMath.tcc
Tables/Table.h
Tables/TableAttr.h
Tables/TableCache.h
Tables/TableColumn.h
Tables/TableCopy.h
Tables/TableCopy.tcc
Tables/TableDesc.h
Tables/TableError.h
Tables/TableIndexProxy.h
Tables/TableInfo.h
Tables/TableIter.h
Tables/TableIterProxy.h
Tables/TableKeyword.h
Tables/TableLock.h
Tables/TableLockData.h
Tables/TableLocker.h
Tables/TableProxy.h
Tables/TableRecord.h
Tables/TableRecordRep.h
Tables/TableRow.h
Tables/TableRowProxy.h
Tables/TableSyncData.h
Tables/TableTrace.h
Tables/TableVector.h
Tables/TableVector.tcc
DESTINATION include/casacore/tables/Tables
)

install (FILES
DataMan/BaseMappedArrayEngine.h
DataMan/BaseMappedArrayEngine.tcc
DataMan/BitFlagsEngine.h
DataMan/BitFlagsEngine.tcc
DataMan/CompressComplex.h
DataMan/CompressFloat.h
DataMan/DataManAccessor.h
DataMan/DataManError.h
DataMan/DataManInfo.h
DataMan/DataManager.h
DataMan/ForwardCol.h
DataMan/ForwardColRow.h
DataMan/ISMBase.h
DataMan/ISMBucket.h
DataMan/ISMColumn.h
DataMan/ISMIndColumn.h
DataMan/ISMIndex.h
DataMan/IncrStManAccessor.h
DataMan/IncrementalStMan.h
DataMan/MSMBase.h
DataMan/MSMColumn.h
DataMan/MSMDirColumn.h
DataMan/MSMIndColumn.h
DataMan/MappedArrayEngine.h
DataMan/MappedArrayEngine.tcc
DataMan/MemoryStMan.h
DataMan/RetypedArrayEngine.h
DataMan/RetypedArrayEngine.tcc
DataMan/RetypedArraySetGet.h
DataMan/RetypedArraySetGet.tcc
DataMan/SSMBase.h
DataMan/SSMColumn.h
DataMan/SSMDirColumn.h
DataMan/SSMIndColumn.h
DataMan/SSMIndStringColumn.h
DataMan/SSMIndex.h
DataMan/SSMStringHandler.h
DataMan/ScaledArrayEngine.h
DataMan/ScaledArrayEngine.tcc
DataMan/ScaledComplexData.h
DataMan/ScaledComplexData.tcc
DataMan/StArrAipsIO.h
DataMan/StArrayFile.h
DataMan/StIndArrAIO.h
DataMan/StIndArray.h
DataMan/StManAipsIO.h
DataMan/StManColumn.h
DataMan/StandardStMan.h
DataMan/StandardStManAccessor.h
DataMan/TSMColumn.h
DataMan/TSMCoordColumn.h
DataMan/TSMCube.h
DataMan/TSMCubeBuff.h
DataMan/TSMCubeMMap.h
DataMan/TSMDataColumn.h
DataMan/TSMFile.h
DataMan/TSMIdColumn.h
DataMan/TSMOption.h
DataMan/TSMShape.h
DataMan/TiledCellStMan.h
DataMan/TiledColumnStMan.h
DataMan/TiledDataStMan.h
DataMan/TiledDataStManAccessor.h
DataMan/TiledFileAccess.h
DataMan/TiledFileHelper.h
DataMan/TiledShapeStMan.h
DataMan/TiledStMan.h
DataMan/TiledStManAccessor.h
DataMan/VSCEngine.h
DataMan/VSCEngine.tcc
DataMan/VirtArrCol.h
DataMan/VirtArrCol.tcc
DataMan/VirtColEng.h
DataMan/VirtScaCol.h
DataMan/VirtScaCol.tcc
DataMan/VirtualTaQLColumn.h
DESTINATION include/casacore/tables/DataMan
)

install (FILES
TaQL/ExprAggrNode.h
TaQL/ExprAggrNodeArray.h
TaQL/ExprConeNode.h
TaQL/ExprDerNode.h
TaQL/ExprDerNodeArray.h
TaQL/ExprFuncNode.h
TaQL/ExprFuncNodeArray.h
TaQL/ExprGroup.h
TaQL/ExprGroupAggrFunc.h
TaQL/ExprGroupAggrFuncArray.h
TaQL/ExprLogicNode.h
TaQL/ExprLogicNodeArray.h
TaQL/ExprMathNode.h
TaQL/ExprMathNodeArray.h
TaQL/ExprNode.h
TaQL/ExprNodeArray.h
TaQL/ExprNodeRecord.h
TaQL/ExprNodeRep.h
TaQL/ExprNodeSet.h
TaQL/ExprRange.h
TaQL/ExprUDFNode.h
TaQL/ExprUDFNodeArray.h
TaQL/ExprUnitNode.h
TaQL/MArrayBase.h
TaQL/MArrayLogical.h
TaQL/MArrayMathBase.h
TaQL/MArrayMath.h
TaQL/MArrayUtil.h
TaQL/MArray.h
TaQL/RecordExpr.h
TaQL/RecordGram.h
TaQL/TaQLNode.h
TaQL/TaQLNodeDer.h
TaQL/TaQLNodeHandler.h
TaQL/TaQLNodeRep.h
TaQL/TaQLNodeResult.h
TaQL/TaQLNodeVisitor.h
TaQL/TaQLResult.h
TaQL/TaQLShow.h
TaQL/TaQLStyle.h
TaQL/TableExprData.h
TaQL/TableExprId.h
TaQL/TableExprIdAggr.h
TaQL/TableGram.h
TaQL/TableParse.h
TaQL/UDFBase.h
DESTINATION include/casacore/tables/TaQL
)

install (FILES
LogTables/LogFilterTaql.h
LogTables/LoggerHolder.h
LogTables/TableLogSink.h
LogTables/LogFilterExpr.h
LogTables/NewFile.h
DESTINATION include/casacore/tables/LogTables
)

install (FILES
DataMan.h
LogTables.h
Tables.h
TaQL.h
DESTINATION include/casacore/tables
)

# Temporary install of stub header files.
install (FILES
Tables/BitFlagsEngine.h
Tables/CompressComplex.h
Tables/CompressFloat.h
Tables/DataManAccessor.h
Tables/DataManError.h
Tables/DataManager.h
Tables/ExprNode.h
Tables/ExprNodeSet.h
Tables/ForwardCol.h
Tables/ForwardColRow.h
Tables/IncrStManAccessor.h
Tables/IncrementalStMan.h
Tables/RecordGram.h
Tables/ScaledArrayEngine.h
Tables/ScaledComplexData.h
Tables/StManAipsIO.h
Tables/StandardStMan.h
Tables/StandardStManAccessor.h
Tables/TSMOption.h
Tables/TableExprId.h
Tables/TableParse.h
Tables/TiledCellStMan.h
Tables/TiledColumnStMan.h
Tables/TiledDataStMan.h
Tables/TiledDataStManAccessor.h
Tables/TiledShapeStMan.h
Tables/TiledStManAccessor.h
Tables/UDFBase.h
DESTINATION include/casacore/tables/Tables
)

add_subdirectory (Tables/test ${EXCL_ALL})
add_subdirectory (DataMan/test ${EXCL_ALL})
add_subdirectory (TaQL/test ${EXCL_ALL})
add_subdirectory (LogTables/test ${EXCL_ALL})

=== ms/apps/CMakeLists.txt ===
foreach(prog msselect writems readms)
    add_executable (${prog}  ${prog}.cc)
    target_link_libraries (${prog} casa_ms ${CASACORE_ARCH_LIBS})
    install(TARGETS ${prog} DESTINATION bin)
endforeach(prog msselect)

=== tables/apps/CMakeLists.txt ===
foreach(prog showtableinfo showtablelock taql lsmf tomf tablefromascii)
    add_executable (${prog}  ${prog}.cc)
    target_link_libraries (${prog} casa_tables)
    install(TARGETS ${prog} DESTINATION bin)
endforeach()

=== casa/Containers/test/CMakeLists.txt ===
set (tests
tBlock
tBlockTrace
tHashMap
tHashMapIO
tHashMapIter
tList
tObjectStack
tOrdMap2
tOrdMap
tQueue
tRecord
tRecordDesc
tSimOrdMap
tStack
tValueHolder
)

foreach (test ${tests})
    add_executable (${test} ${test}.cc)
    target_link_libraries (${test} casa_casa)
    add_test (${test} ${CMAKE_SOURCE_DIR}/cmake/cmake_assay ./${test})
    add_dependencies(check ${test})
endforeach (test)

=== casa/OS/test/CMakeLists.txt ===
set (tests
tCanonicalConversion
tConversion
tConversionPerf
tDataConversion
tDirectory
tDirectoryIterator
tEnvVar
tFile
tHostInfo
tIBMConversion
tLECanonicalConversion
tMemory
tMemoryTrace
tModcompConversion
tMutex
tPath
tPrecTimer
tRegularFile
tSymLink
tTime
tTimer
tVAXConversion
)

foreach (test ${tests})
    add_executable (${test} ${test}.cc)
    target_link_libraries (${test} casa_casa)
    add_test (${test} ${CMAKE_SOURCE_DIR}/cmake/cmake_assay ./${test})
    add_dependencies(check ${test})
endforeach (test)

=== lattices/LRegions/test/CMakeLists.txt ===
set (tests
tLatticeRegion
tLCComplement
tLCConcatenation
tLCDifference
tLCEllipsoid
tLCExtension
tLCIntersection
tLCLELMask
tLCMask
tLCPagedMask
tLCPixelSet
tLCPolygon
tLCPolygon2
tLCRegion
tLCSlicer
tLCStretch
tLCUnion
)

foreach (test ${tests})
    add_executable (${test} ${test}.cc)
    target_link_libraries (${test} casa_lattices)
    add_test (${test} ${CMAKE_SOURCE_DIR}/cmake/cmake_assay ./${test})
    add_dependencies(check ${test})
endforeach (test)

=== lattices/LatticeMath/test/CMakeLists.txt ===
set (tests
tFit2D
tLatticeAddNoise
tLatticeApply
tLatticeApply2
tLatticeConvolver
tLatticeFFT
tLatticeFit
tLatticeFractile
tLatticeHistograms
tLatticeMathUtil
tLatticeSlice1D
tLatticeStatistics
tLatticeStatsDataProvider
tLatticeTwoPtCorr
tLattStatsSpecialize
)

foreach (test ${tests})
    add_executable (${test} ${test}.cc)
    target_link_libraries (${test} casa_lattices)
    add_test (${test} ${CMAKE_SOURCE_DIR}/cmake/cmake_assay ./${test})
    add_dependencies(check ${test})
endforeach (test)

=== meas/MeasUDF/test/CMakeLists.txt ===
set (tests
 tPositionEngine
 tEpochEngine
 tDirectionEngine
 tEarthMagneticEngine
 tFrequencyEngine
 tRadialVelocityEngine
 tDopplerEngine
 tmeas
)

foreach (test ${tests})
    add_executable (${test} ${test}.cc)
    target_link_libraries (${test} casa_meas)
    add_test (${test} ${CMAKE_SOURCE_DIR}/cmake/cmake_assay ./${test})
    add_dependencies(check ${test})
endforeach (test)

=== ms/MeasurementSets/test/CMakeLists.txt ===
#foreach (files
#antenna.params
#feed.params
#field.params
#obs.params
#range-obs.params
#selector-obs.params
#spw.params
#)
#    configure_file (${CMAKE_CURRENT_SOURCE_DIR}/${files} ${CMAKE_CURRENT_BINARY_DIR}#/${files} COPYONLY)
#endforeach (files)

set (tests
tMeasurementSet
tMSColumns
tMSDataDescBuffer
tMSFieldBuffer
tMSFieldEphem
tMSIter
tMSMainBuffer
tMSPolBuffer
tStokesConverter
)

foreach (test ${tests})
	add_executable (${test} ${test}.cc)
	target_link_libraries (${test} casa_ms)
	add_test (${test} ${CMAKE_SOURCE_DIR}/cmake/cmake_assay ./${test})
	add_dependencies(check ${test})
endforeach (test)

=== debian/changelog ===
casacore (3.0.0-4) unstable; urgency=low

  * Switch back to unstable. Start transition.

 -- Ole Streicher <olebole@debian.org>  Fri, 23 Nov 2018 17:43:45 +0100

casacore (3.0.0-3) experimental; urgency=medium

  * Fix another compile error in LatticeMath on 32 bit platforms

 -- Ole Streicher <olebole@debian.org>  Thu, 22 Nov 2018 08:13:35 +0100

casacore (3.0.0-2) experimental; urgency=medium

  * Fix compile error in LatticeApply in 32 bit platforms
  * Fix another kfreebsd64 problem

 -- Ole Streicher <olebole@debian.org>  Wed, 21 Nov 2018 13:56:28 +0100

casacore (3.0.0-1) experimental; urgency=medium

  * New upstream version 3.0.0 Rediff patches
  * Push Standards-Version to 4.2.1. No changes needed
  * Adjust SOVERSION for all libs. Switch to experimental to prepare transition

 -- Ole Streicher <olebole@debian.org>  Sun, 18 Nov 2018 14:49:06 +0100

casacore (2.4.1-3) unstable; urgency=low

  * Fix version number comparison for numpy
  * Fix boost-python detection for the new upstream sonames.

 -- Ole Streicher <olebole@debian.org>  Mon, 06 Aug 2018 10:10:20 +0200

casacore (2.4.1-2) unstable; urgency=medium

  * Update VCS fields to use salsa.d.o
  * Removed unused manpage of showtable (1)
  * Keep numpy 1.13 printoption for numpy 1.14 or above (Closes: #904853)
  * Push Standards-Version to 4.1.5. No changes needed.
  * Push compat to 11

 -- Ole Streicher <olebole@debian.org>  Thu, 02 Aug 2018 10:56:27 +0800

=== debian/control ===
Source: casacore
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Benda Xu <heroxbd@gentoo.org>, Ole Streicher <olebole@debian.org>
Build-Depends: bison,
               cmake (>= 1.6.2),
               debhelper (>= 11),
               doxygen,
               flex,
               gfortran,
               graphviz,
               libblas-dev,
               libboost-python-dev,
               libcfitsio-dev,
               libfftw3-dev,
               liblapack-dev,
               libncurses5-dev,
               libreadline6-dev,
               python-numpy,
               python3-dev,
               python3-numpy,
               wcslib-dev
Standards-Version: 4.2.1
Section: science
Homepage: https://casacore.github.io/casacore
Vcs-Git: https://salsa.debian.org/debian-astro-team/casacore.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/casacore

Package: casacore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcasa-casa3 (= ${binary:Version}),
         libcasa-coordinates3 (= ${binary:Version}),
         libcasa-derivedmscal3 (= ${binary:Version}),
         libcasa-fits3 (= ${binary:Version}),
         libcasa-images3 (= ${binary:Version}),
         libcasa-lattices3 (= ${binary:Version}),
         libcasa-meas3 (= ${binary:Version}),
         libcasa-measures3 (= ${binary:Version}),
         libcasa-mirlib3 (= ${binary:Version}),
         libcasa-ms3 (= ${binary:Version}),
         libcasa-msfits3 (= ${binary:Version}),
         libcasa-python3 (= ${binary:Version}),
         libcasa-scimath-f3 (= ${binary:Version}),
         libcasa-scimath3 (= ${binary:Version}),
         libcasa-tables3 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA core library development files
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the files for application development.

Package: casacore-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: casacore-dev
Description: CASA core library (documentation)
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the API documentation.

Package: casacore-tools
Architecture: any
Depends: python, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tools built with CASA
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the tools built with CASA core:
 .
  * taql - query language for casacore tables
  * measuresdata - create data tables for measures
  * imageregrid, imagecalc, showtable, showtablelock, findmeastable,
    fits2table, imreorder, casahdf5support, msselect,  image2fits,
    imageslice, etc.

Package: libcasa-casa3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA core modules
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Core modules: Multi-dimensional arrays, Quantities
 (values with physical units), OS and IO interface classes, Containers (from
 pre-STL era), Miscellaneous modules for exceptions, tasking interface,
 command line input, logging, STL wrappers, and basic math classes and
 functors.
 .
 Most of the code has been developed before STL came into existence, so
 several classes in modules Containers and Utilities are superseded by their
 STL counterparts. However, they are still used in some casacore
 code. Furthermore, some classes offer some extra functionality compared to
 STL.

Package: libcasa-scimath3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA basic mathematical modules
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the mathematical modules n-dimensional functionals,
 linear and non-linear fitting, and miscellaneous.

Package: libcasa-scimath-f3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA scimath F library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Mathematical modules N-dim functionals,
 linear/non-linear fitting, and miscellaneous.

Package: libcasa-python3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA legacy Python 2 bindings
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the legacy Python 2 bindings.

Package: libcasa-python3-3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA Python bindings
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Python 3 bindings.

Package: libcasa-tables3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA table system
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the database-like table system with advanced query
 language (TaQL).

Package: libcasa-measures3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: casacore-data
Multi-Arch: same
Description: CASA measures library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements measures (i.e. quantities with references frames) and
 their persistency. Examples are the Hour-angle and Declination of a source at
 a certain time and observatory; an Ra/Dec for a certain mean epoch; an
 apparent frequency at a certain time given in eV; a local sidereal time at an
 observatory. Measures can be converted from one reference frame to another
 (and this possibility is its main reason for existence).

Package: libcasa-lattices3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA lattice library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements memory- or disk-based N-dimensional arrays (lattices)
 with masking, regions, expressions, and math.

Package: libcasa-fits3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA FITS library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains a C++ interface to read and write FITS files.

Package: libcasa-ms3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA MeasurementSet library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the data format for visibility data as described in the
 MeasurementSet definition. The MeasurementSet is where all data are
 ultimately to be found in CASA.

Package: libcasa-derivedmscal3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA derived mscal library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains derived MeasurementSet quantities (like hourangle) that
 can be used as virtual table columns or as TaQL user defined functions.

Package: libcasa-msfits3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA msfits library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the mapping of MeasurementSets to/from FITS.

Package: libcasa-coordinates3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA coordinates library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the implementation of coordinates for astronomical
 images.

Package: libcasa-images3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA image processing library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements n-dimensional images with masks, coordinates, and
 history.

Package: libcasa-meas3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA functions handling measures
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This module extends TaQL (the Table Query Language) with functions handling
 measures. Currently it can handle directions, epochs, and positions.

Package: libcasa-mirlib3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA mirlib library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
ifeq ($(DEB_HOST_ARCH_CPU),i386)
    export DEB_CXXFLAGS_MAINT_APPEND = -msse -msse2 -mfpmath=sse
endif
ifeq ($(DEB_HOST_ARCH_OS),hurd)
    THREADS=OFF
else
    THREADS=ON
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=ON -DUSE_FFTW3=ON -DUSE_HDF5=OFF \
		-DUSE_THREADS=$(THREADS) -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DDATA_DIR=/var/lib/casacore/data -DBUILD_PYTHON3=ON -DBUILD_TESTING=True

override_dh_auto_build-indep:
	doxygen doxygen.cfg
	rm -f doc/html/jquery.js

override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_test-arch:
	HOME=$(CURDIR) dh_auto_test --max-parallel=1 -a

override_dh_clean:
	dh_clean
	rm -rf doc
